%% Infos
% Mini Course 2021: MATLAB
% DAY1: Basics of programming and data analysis
% Speaker: Alexey Martyushev
% Date: July 26, 2021
% Supplemental Information
% Author: Kang
% Last Updated: July 26, 2021

%% MATLAB IDE

%% BASIC OPERATION
% Example 1: Assign Variables
% The default datatype of values in Matlab is double precision
% Semi colum can hide execution result
% Use "format" to change the display of values
clear;
n_v = 123;
Duration_Spikes = 0.785
n_v
class(n_v)
class(Duration_Spikes)
t_spike = [];

s_v = 'SOME TEXT'
class(s_v)
% Example 2: Display String
% Funtion "disp" display the values, no need to be string.
disp('SOME TEXT')
disp(s_v)
disp(n_v)
disp(num2str(n_v))

% Formatting string values
fprintf('n_v is equal to %i.\n', n_v);
float_point_variable1 = 123456789.123456789;
float_point_variable2 = 12.34;
fprintf('n_v is equal to %6.2f.\n', float_point_variable1);
fprintf('n_v is equal to %08.2f.\n', float_point_variable2);

% Matrix
matrix1 = [1, 3, 4, 5, 7];
matrix2 = [1; 2; 7; 8; 9];
matrix3 = [1, 2, 3, 4; 5, 6, 7, 8; 9, 10, 11, 12];

% Change elements in a matrix
disp("Before: ")
matrix1
disp("After: ")
matrix1(2) = 123

disp("Before: ")
matrix3
disp("After: ")
matrix3(3,2) = 111

%% Example 3: Condition Statement (if-elseif-else)
a = 8;
b = 6;
if (a > b)
	disp('a is greater than b');
elseif (a == b)
	disp('a is equal to b'); 
else
	disp('a is less than b'); 
end

%% Example 4: Condition Statement (for loop)
a = 7;
n = 10;
for i = 1:10
	if (i > a)
		fprintf('i = %i\tis greater than\ta = %i \n', i, a);
	elseif (i == a)
		fprintf('i = %i\tis equal to\ta = %i \n', i, a);
	else
		fprintf('i = %i\tis less than\ta = %i \n', i, a);
	end
end

%% Exercise #1
clear;
users_age = [18, 65, 34, 40, 25, 24, 45, 21, 34, 27, 22, 16, 21];
% Method 1
for i = 1:length(users_age)
    if users_age(i) >= 18 & users_age(i) <= 24
        fprintf('The number %02d user is in the range (18 ~ 24 yo): %d yo\n',i,users_age(i));
    end
end

fprintf('\n');

% Method 2
indicies = find(users_age>=18 & users_age<=24);
fprintf('The number %02d user is in the range (18 ~ 24 yo): %d yo\n', indicies, users_age(indicies));

%% Exercise #2
clear;
users_age = [18, 65, 34, 40, 25, 24, 45, 21, 34, 27, 22, 16, 21];

fprintf('\n');

i = 1;
while i <= length(users_age)
    if users_age(i)>=18 & users_age(i)<=24
        fprintf('The number %02d user is in the range (18 ~ 24 yo): %d yo\n',i,users_age(i));
    end
    i = i + 1;
end

%% MATRIX COMPUTATIONS
% Example 1: Matrix Operation
clear;
A = [1, 2, 3, 4; 5, 6, 7, 8; 9, 10, 11, 12]
b = [1; 2; 3; 4]

A * b

c = [5, 6, 7, 8]
d = [9, 10, 11, 12]

c + d

E = [10, 11, 16, 12; 3, 8, 6, 9; 2, 1, 3, 0];

A + E

a = [1:5]
a>3
a(a>3)
a.*a

%% Exercise #3
clear;
fruitName = {'apples'; 'bananas'; 'mango'; 'pineapples'};
fN = sort(fruitName);
prices = [0.99 1.99 2.99 3.99];
quan_1 = randi(10,1,4);
quan_2 = randi(10,1,4);
quan_3 = randi(10,1,4);

totalAmount = quan_1 + quan_2 + quan_3;
totalPriceEach = totalAmount.*prices;
fprintf('%s','Fruit Name'),fprintf('\t\t%s',fruitName{:})
fprintf('%s\t','Price'),fprintf('\t\t%4.3f',totalPriceEach)
fprintf('-------------------------------------------------------------------------------------------------');
fprintf('%s\t\t\t\t\t\t\t\t\t\t\t %4.3f\n','Sum',sum(totalPriceEach));

%% Exercise #4
clear;
users_age = [18, 65, 34, 40, 25, 24, 45, 21, 34, 27, 22, 16, 21];
% Find numbers of user
detect = [users_age >= 18 & users_age <= 24];
indices = find(detect==true);

fprintf('Quantity of user in range: %d',length(indices));
fprintf('Number of User in the range');
fprintf('User Number: %02d\n',indices);

% Find age in range
ageInRange = users_age(users_age >= 18 & users_age <= 24);
fprintf('Number of User in the range (with their ages)');
fprintf('User Number: %02d, age: %d\n',[indices;ageInRange])


%% DATA I/O
% Example #1: Read CSV Files
% Function csvread will only read data which is number. If a data file contenting texts, they will be ignored.
clear;
antigenA_control = csvread('antigenA_control.csv');
antigenB_control = csvread('antigenB_control.csv'); 	
antigenC_control = csvread('antigenC_control.csv');

antigenA_treatment = csvread('antigenA_treatment.csv'); 	
antigenB_treatment = csvread('antigenB_treatment.csv');
antigenC_treatment = csvread('antigenC_treatment.csv');

resTable = [antigenA_control(:,1),...
            antigenA_control(:,2),...
            antigenB_control(:,2),...
            antigenC_control(:,2),...
            antigenA_treatment(:,2),...
            antigenB_treatment(:,2),...
            antigenC_treatment(:,2)];

antigenLabel = {'antigen A (control)',...
                'antigen B (control)',...
                'antigen C (control)',...
                'antigen A (treatment)',...
                'antigen B (treatment)',...
                'antigen C (treatment)'};
% Example #2: Visualize Data
figure;
plot(resTable(:,1), resTable(:,2));
title('Antigen A Control');xlabel('Time (days)');ylabel('Antigen Level (IU/ml)');

figure;
plot(resTable(:,1), resTable(:,[2:7]))
title('All Antigen');xlabel('Time (days)');ylabel('Antigen Level (IU/ml)');
legend(antigenLabel)

figure;
semilogy(resTable(:,1), resTable(:,[2:7]))
title('All Antigen');xlabel('Time (days)');ylabel('Log_{10}{Antigen Level} (IU/ml)');
legend(antigenLabel)

%% Fitting DATA (OPTIMIZATION)
% Example #1
t = resTable(:,1);

%% Exercise #5
for i = 2:size(resTable,2)
    eval(sprintf('y%s = resTable(:,i);',num2str(i-1)));
end

% cftool




