%% Clear the previous variables and close all the figures so that you
%% make sure you don't plot on the wrong figure or the wrong variable
clear all 
close all 

%% Our first plotting example in Matlab 
figure(1)
time= 1:7;
param1 = [30 34 80 75 91 10 5];
plot(time,param1); 
title('time vs param'); 
xlabel('time');
ylabel('param1')
set(gca,'FontSize',20)

%% add options to the plot: linewidth and color
figure(2)
plot(time,param1,'LineWidth',3,'Color','r');
title('time vs param'); 
xlabel('time');
ylabel('param1');
set(gca,'FontSize',20)

%% add more options such as marker, color the marker, etc
figure(3)
plot(time,param1,'LineWidth',3,'Color','k','Marker','s','MarkerSize',30,'MarkerEdgeColor','b','MarkerFaceColor','g');
title('time vs param'); 
xlabel('time');
ylabel('param1');
set(gca,'FontSize',20)

%% set the limits you want and show the values you want on the axis.
figure(4)
plot(time,param1,'LineWidth',3,'Color','r');
title('time vs param'); 
xlabel('time');
ylabel('param1');
xlim([0,8]);
ylim([0,120]);
xticks([1 4 6]);
set(gca,'FontSize',20)
%xtickangle(90)
%xticklabels ({ 'label' , 'label2' , 'label3'})

%% define one more vector and pot both params on the same graph: 

param2 = [6 20 70 50 80 20 5]
figure(5)
plot(time,param1,'LineWidth',3,'Color','r')
hold on
plot(time,param2,'-.','LineWidth',2,'Color','b')
xlabel('time');
ylabel('params')
set(gca,'FontSize',20)
legend('param1','param2')


param3 = [8 10 90 100 90 10 8]
figure(6)
plot(time,param1,'LineWidth',3,'Color','r')
hold on
plot(time,param2,'-.','LineWidth',2,'Color','b')
hold on
plot(time,param3,'--','LineWidth',2.5,'Color','m');
xlabel('time');
ylabel('params')
set(gca,'FontSize',20)
legend('param1','param2','param3')
hgexport(gcf, 'Figure6_betterres', hgexport('factorystyle'), 'Format', 'jpeg','Resolution','1000')

