
clear all; close all

%% COORDINATE VECTORS AND MATRICES
x_line = linspace(-3,3,50);
y_line = linspace(-3,3,50);

[x, y] = meshgrid(x_line, y_line);


%% DEFINE THE FUNCTION WE WILL PLOT
z = sin(x) .* sin(y);


%% MAKE PRETTY PLOTS
figure(1)
contour(x,y,z)
axis square
colorbar
title('contour')

figure(2)
contourf(x,y,z)
axis square
colorbar
title('contourf')

figure(3)
pcolor(x,y,z)
axis square
colorbar
title('pcolor')
hgexport(gcf, 'name_of_figure', hgexport('factorystyle'), 'Format','jpeg','Resolution','1000')


figure(4)
%subplot(3,2,5)
surf(x,y,z)
colorbar
title('surf')
%lightangle(100,180)
%lighting gouraud

figure(5)
pcolor(x,y,z)
axis square
colorbar
title('pcolor')
shading flat

figure(6)
surf(x,y,z)
colorbar
title('surf')
shading interp

figure(6)
hgexport(gcf, 'name_of_figure', hgexport('factorystyle'), 'Format','jpeg','Resolution','500')

