%% Answer Luis's question
% Author: Gabriel/Kang
% Last Update: 2021/07/28
clear all; close all;clc;

%% COORDINATE VECTORS AND MATRICES
x_line = linspace(-3,3,50);
y_line = linspace(-3,3,50);

[x, y] = meshgrid(x_line, y_line);


%% DEFINE THE FUNCTION WE WILL PLOT
z = sin(x) .* sin(y);


%% MAKE PRETTY PLOTS
fig = figure(1);

ax1 = subplot(221);
contour(x,y,z)
axis square
colorbar
title('contour')

ax2 = subplot(222);
contourf(x,y,z)
axis square
colorbar
title('contourf')

ax3 = subplot(223);
pcolor(x,y,z)
axis square
colorbar
title('pcolor')
hgexport(gcf, 'name_of_figure', hgexport('factorystyle'), 'Format','jpeg','Resolution','1000')


ax4 = subplot(224);
surf(x,y,z)
colorbar
title('surf')

%% use the axes info to change setting
colormap(ax4, 'hot')

