
clear all
close all

%% COORDINATE VECTORS AND MATRICES
x_line = linspace(-3,3,50);
y_line = linspace(-3,3,50);

[x, y] = meshgrid(x_line, y_line);


%% DEFINE THE FUNCTION WE WILL PLOT
z = sin(x) .* sin(y);

colormap spring
%% MAKE PRETTY PLOTS
figure(1)
subplot(2,3,1)
contour(x,y,z)
axis square
colorbar
title('contour')

subplot(2,3,2)
contourf(x,y,z)
axis square
colorbar
title('contourf')

subplot(2,3,3)
pcolor(x,y,z)
axis square
colorbar
title('pcolor')

subplot(2,3,4)
pcolor(x,y,z)
axis square
shading flat
colorbar
title('pcolor + shading interp')

subplot(2,3,5)
surf(x,y,z)
colorbar
title('surf')
axis square
lightangle(100,180)
lighting gouraud

subplot(2,3,6)
surf(x,y,z)
colorbar
axis square
title('surf + shading interp')
shading interp
lightangle(100,180)
lighting gouraud

