clear all
close all

%% Let's solve Example 1: 
% SOLVE x' = 2exp(-t)
%for x(0)=0

%Step 1: Define time scale
t = 0:0.1:5;
%Step 2: Define initial conditions: 
IC = 0;
%Step 3: Call the desired ODE solver 
[t,x] = ode45(@rhs,t,IC)


figure(1)
plot(t,x,'LineWidth',2,'Color','r')
set(gca,'FontSize',20)
xlabel('t');
ylabel('x');
title('Example1 - ode45')
saveas(figure(1),'Example1.jpg')


%% Lets plot the analytical solution: 
x2 = -2*exp(-t)+2;
figure(2)
plot(t,x2,'x','MarkerSize',10,'Color','b','LineWidth',2);
set(gca,'FontSize',20)
xlabel('t');
ylabel('x');
title('Example1 - analytical')
saveas(figure(2),'Example1b.jpg')

%% Let's practice plotting them on the same graph:
figure(3)
plot(t,x,'LineWidth',2,'Color','r');
hold on
plot(t,x2,'x','MarkerSize',10,'Color','b','LineWidth',2);
set(gca,'FontSize',20)
xlabel('t');
ylabel('x');
legend('ode45','analytical')
title('Example1: ode45 vs analytical')
saveas(figure(3),'Example1ab.jpg')




