%% Solve the Van der Pol equation via ode45
% Define the time interval: 
clear all
close all

ti =[0 20]; 
ic =[1 0]; % i.e. (v(1),v(2)) =(1,0)

[t,v] = ode45('vdp',ti,ic);

figure(1)
plot(t,v(:,1),'m',t,v(:,2),'b-*');
set(gca,'FontSize',20);
xlabel('t');
ylabel('v');
legend('v[1]','v[2]');
saveas(figure(1),'Example21.jpg')

%Plot phase plane: 
figure(2)
plot(v(:,1),v(:,2),'r-','LineWidth',5);
set(gca,'FontSize',20);
xlabel('v[1]');
ylabel('v[2]');
saveas(figure(2),'Example22.jpg')


% 
% figure(3)
% plot(t,v(:,1))
% set(gca,'FontSize',20);
% xlabel('t');
% ylabel('v[1]');
% 
% figure(4)
% plot(t,v(:,2))
% set(gca,'FontSize',20);
% xlabel('t');
% ylabel('v[2]');