clear all
close all

% Solve the predator prey model
% initial conditions 
%y0 = [6,2];
y0 =[70,20];

% timespan
t0 = 0; % initial time
tfinal = 40; % final time
dt = 0.01; % time increment

tspan = [t0:dt:tfinal];



% call the ode solver
[t,Y] = ode45('predatorprey',[t0,tfinal],y0);

% plot
figure(20);
hold; 
% Plot the change in prey population
plot(t,Y(:,1),'b -*','LineWidth',4)
% Plot the change in predator population
plot(t,Y(:,2),'r -s','LineWidth',4)
hold; 
legend('Prey','Predators','FontSize',20)
set(gca,'FontSize',20)
xlabel('time')
ylabel('y')

figure(21)
plot(Y(:,1),Y(:,2),'r','LineWidth',4)
xlabel('prey');
ylabel('predator')
set(gca,'FontSize',20)
