close all
clear all
clc

Main='C:\Users\Charlotte\Desktop\Atsushi\';
Name='code400_2_7cm_9p7um_2p5uLmin_250fps_1_190530.tif';

%% Reading Images
warning('off','all') % Suppress all the tiff warnings
tstack  = Tiff([Main Name]);
[I,J] = size(tstack.read());
Ni = length(imfinfo([Main Name]));
data = zeros(I,J,Ni);
data(:,:,1)  = tstack.read();
for ni = 2:Ni
    clc
    disp(['Oppening tiff ' Name ', ' num2str(round(ni/Ni*100)) '%'])
    tstack.nextDirectory()
    data(:,:,ni) = tstack.read();
end
warning('on','all') % Suppress all the tiff warnings

%% Displaying image
DoFig=1;
Back=data(:,:,1);
Center=NaN(Ni,2);
Rad=NaN(Ni,1);
for ni=500:Ni
    clc
    disp(['Detection ' num2str(round(ni/Ni*100)) '%'])
    if DoFig==1
        figure(1)
        subplot(2,1,1)
        imagesc(data(:,:,ni))
        colormap gray
        axis equal
        hold on
    end
    
    A=-data(:,:,ni)+Back;
    B=imfill(A);
    C=imbinarize(B,20);
    E=bwconncomp(C);
    center=regionprops(E,'centroid');
    center= cat(1,center.Centroid);
    Ma=regionprops(E,'MajorAxisLength');
    Ma= cat(1,Ma.MajorAxisLength);
    ma=regionprops(E,'MinorAxisLength');
    ma= cat(1,ma.MinorAxisLength);
    rad=(ma+Ma)/4;
    i_bad=find(rad<1 | Ma./ma>2);
    center(i_bad,:)=[];
    rad(i_bad)=[];
    
    if isempty(rad)
        getframe;
        continue;
    end
    
    [rmax,iobj]=max(rad);
    Center(ni,:)=center(iobj,:);
    Rad(ni,:)=rad(iobj);
    
    if DoFig==1
        viscircles(Center(ni,:),Rad(ni,:))
        subplot(2,1,2)
        imagesc(C)
        colormap gray
        axis equal
        subplot(2,1,1)
        scatter(Center(max(ni-20,1):ni,1),Center(max(ni-20,1):ni,2),Rad(max(ni-20,1):ni),'b')
        hold off
        getframe;
    end
end



