close all
clear all
clc

%% Oppening video
Dir='C:\Users\Charlotte\Desktop\Rameez\';
mov=VideoReader([Dir 'EvDrop.avi']);
Ni=mov.FrameRate*mov.Duration; % Number of image in the video
Ny=mov.Width;
Nx=mov.Height;
Im=NaN(Nx,Ny,Ni);
figure(1)
for ni=1:Ni
    Im(:,:,ni)=rgb2gray(readFrame(mov)); % ni th image of the video
    imagesc(Im(:,:,ni))
    colormap gray
    axis equal
    getframe;
end

%% Segmenting contour
figure(2)
Bound=cell(Ni,1);
for ni=1:Ni-1
    A=-Im(:,:,ni)+Im(:,:,end);
    B=imbinarize(A,100);
    E=bwboundaries(B,'noholes');
    Long=cellfun('length',E);
    [~,i_L]=max(Long);
    Bound(ni)=E(i_L);
        imagesc(B)
        colormap gray
        hold on
        plot(Bound{ni}(:,2),Bound{ni}(:,1),'r')
                xlim([600 1600])
        ylim([400 700])
        hold off
        getframe;
end

%% Finding interface
figure(3)
[~,i_piks]=findpeaks(smooth(Bound{end-1}(:,2)));
y_int=Bound{end-1}(i_piks,1);

%% Computing angle
cmp=jet(Ni);
figure(4)
clf
a=NaN(Ni,2);
Rb=NaN(Ni,1);
Rt=NaN(Ni,1);
Rf=NaN(Ni,1);
for ni=1:Ni-1
    i_drp=find(Bound{ni}(:,1)<y_int);
    Y=-Bound{ni}(i_drp,1);
    X=Bound{ni}(i_drp,2);
    X=X-nanmean(X);
    Y=Y-nanmean(Y);
    Y2=Y;
    Y2(X>0.8*min(X))=NaN;
    [~,i_start]=min(Y2);
    X=circshift(X,-i_start);
    Y=circshift(Y,-i_start);
    Y2=Y;
    Y2(X<0.8*max(X))=NaN;
    [~,i_end]=min(Y2);
    X=X(1:i_end);
    Y=Y(1:i_end);
    Rf(ni)=(max(X)-min(X))/2;
    Rb(ni)=(X(end)-X(1))/2;
    Rt(ni)=max(Y)-min(Y);
    scale=nanmean(diff(X));
    
    Plage=min(20,Rb(ni)/2*scale);
    p=polyfit(Y(1:Plage),X(1:Plage),1);
    Xf=polyval(p,Y(1:Plage));
    p2=polyfit(Y(end-Plage:end),X(end-Plage:end),1);
    Xf2=polyval(p2,Y(end-Plage:end));
    a(ni,1)=(p(end-1));
    a(ni,2)=-(p2(end-1));
    
    plot(X,Y)
    hold on
    plot(Xf,Y(1:Plage),'-r')
    plot(Xf2,Y(end-Plage:end),'-r')
    hold off
    getframe;
end

%% Final plot
alpha=pi/2-atan(a);
alpha(alpha<0)=pi+alpha(alpha<0);
figure()
subplot(2,1,1)
plot(1:Ni,alpha)
legend('Left angle','Right angle')
xlabel('Image')
ylabel('contact angle')
subplot(2,1,2)
plot(1:Ni,Rb)
hold on
plot(1:Ni,Rf)
plot(1:Ni,Rt)
hold off
legend('Radius of the base','Largest Radius','Height')
xlabel('Image')
ylabel('Radius')

