function [Im] = BinaryObjects()

%%
Si=1000;
Im=zeros(Si);

% Ellipse1
[columnsInImage rowsInImage] = meshgrid(1:Si, 1:Si);
% Next create the ellipse in the image.
centerX = 100;
centerY = 100;
radiusX = 70;
radiusY = 20;
ellipsePixels1 = (rowsInImage - centerY).^2 ./ radiusY^2 ...
    + (columnsInImage - centerX).^2 ./ radiusX^2 <= 1;
% ellipsePixels is a 2D "logical" array.

% Ellipse2
[columnsInImage rowsInImage] = meshgrid(1:Si, 1:Si);
% Next create the ellipse in the image.
centerX = 300;
centerY = 500;
radiusX = 30;
radiusY = 80;
ellipsePixels2 = (rowsInImage - centerY).^2 ./ radiusY^2 ...
    + (columnsInImage - centerX).^2 ./ radiusX^2 <= 1;
% ellipsePixels is a 2D "logical" array.
ellipsePixels2=imrotate(ellipsePixels2,20,'crop');

% Circle
[columnsInImage rowsInImage] = meshgrid(1:Si, 1:Si);
% Next create the ellipse in the image.
centerX = 800;
centerY = 100;
radius = 50;
CircPix = (rowsInImage - centerY).^2 ./ radius^2 ...
    + (columnsInImage - centerX).^2 ./ radius^2 <= 1;
% ellipsePixels is a 2D "logical" array.

% Ring
[columnsInImage, rowsInImage] = meshgrid(1:Si, 1:Si);
% Next create the circle in the image.
centerX = 500;
centerY = 500;
innerRadius = 60;
outerRadius = 80;
array2D = (rowsInImage - centerY).^2 ...
    + (columnsInImage - centerX).^2;
ringPixels = array2D >= innerRadius.^2 & array2D <= outerRadius.^2;
% ringPixels is a 2D "logical" array.

% Ring
[columnsInImage, rowsInImage] = meshgrid(1:Si, 1:Si);
% Next create the circle in the image.
centerX = 700;
centerY = 800;
innerRadius = 10;
outerRadius = 70;
array2D = (rowsInImage - centerY).^2 ...
    + (columnsInImage - centerX).^2;
ringPixels2 = array2D >= innerRadius.^2 & array2D <= outerRadius.^2;
% ringPixels is a 2D "logical" array.

% Square
Cx=200;
Cy=600;
Lx=100;
Ly=200;
SqPix=zeros(Si);
SqPix(Cx:Cx+Lx,Cy:Cy+Ly)=1;
SqPix=imrotate(SqPix,-50,'crop');

% Square
Cx=600;
Cy=100;
Lx=300;
Ly=50;
SqPix2=zeros(Si);
SqPix2(Cx:Cx+Lx,Cy:Cy+Ly)=1;

% 8
[columnsInImage rowsInImage] = meshgrid(1:Si, 1:Si);
% Next create the ellipse in the image.
centerX = 200;
centerY = 500;
radius = 50;
HPix = (rowsInImage - centerY).^2 ./ radius^2 ...
    + (columnsInImage - centerX).^2 ./ radius^2 <= 1;
HPix2 = (rowsInImage - centerY+40).^2 ./ radius^2 ...
    + (columnsInImage - centerX+40).^2 ./ radius^2 <= 1;
% ellipsePixels is a 2D "logical" array.
HPix=HPix | HPix2;
HPix=imrotate(HPix,-70,'crop');

Im=ellipsePixels1 | ellipsePixels2 | ringPixels | ringPixels2 | SqPix | SqPix2 |  CircPix | HPix; 
imagesc(Im)
axis equal

end

