function [Im] = GreyRandCircles(N1,N2,Noise)
%% Build an image with circle of different gray intensity.
Si=1000;
R=100;

Im=uint8(zeros(Si));
I=repmat((1:Si)',[1,Si]);
J=repmat((1:Si),[Si,1]);
Int=linspace(0,255,N1*N2+2);
C1=linspace(0,Si,N1+2);
C2=linspace(0,Si,N2+2);
for i=1:N1
    for j=1:N2
        Im(((I-C1(i+1)).^2+(J-C2(j+1)).^2<R^2))=Int(sub2ind([N1 N2],i,j)+1);
    end
end

Im=double(Im)+70*rand(size(Im));
Im=imgaussfilt(Im,Noise);

end

