close all
clear all
clc

%% 1/ Open the avi file JumpingDroplet
Im=VideoOpener('JumpingDroplet.AVI');
Ni=size(Im,3);
figure(1)
clf
for ni=1:Ni
    I1=Im(:,:,ni);
    imagesc(I1)
    getframe;
end

%% 2/ Binarize the first image
I1=Im(:,:,1);
figure(1)
subplot(1,3,1)
imagesc(I1)
t=140;
I2=imbinarize(I1,t);
subplot(1,3,2)
imagesc(I2)

%% 3/ Get the position and radius of all objects
E=bwconncomp(I2);
prop=regionprops(E,'Centroid','EquivDiameter');
C=cat(1,prop.Centroid); % C now contains all the center of the objects of the image:
R=cat(1,prop.EquivDiameter)/2;

%% 4/ Segment the bubble for the first image. 
% The bubble is the biggest object
im=find(R==max(R)); % find the biggest object 
v=E.PixelIdxList{3}; % Get pixels of the biggest object
S=zeros(size(I1)); % create a blank image
S(v)=1; % Fill pixels of the bigges object
subplot(1,3,3)
imagesc(S)

%% 5/ Make a loop on each image of the movie.
Ni=size(Im,3);
for ni=1:Ni
I1=Im(:,:,ni);
% The following is just copy-pasted from before
% 2/
t=140;
I2=imbinarize(I1,t);
% 3/ 
E=bwconncomp(I2);
prop=regionprops(E,'Centroid','EquivDiameter');
C=cat(1,prop.Centroid); % C now contains all the center of the objects of the image:
R=cat(1,prop.EquivDiameter)/2;
% 4/ 
im=find(R==max(R)); % find the biggest object 
v=E.PixelIdxList{im}; % Get pixels of the biggest object
S=zeros(size(I1)); % create a blank image
S(v)=1; % Fill pixels of the bigges object

figure(1)
subplot(1,3,1)
imagesc(I1)
title('original')
subplot(1,3,2)
imagesc(I2)
title('threshold')
subplot(1,3,3)
imagesc(S)
title('segmented')
getframe;
end

%% 6/ For each image, segment the bubble, get its position and radius. 
Ni=size(Im,3);
Center=NaN(Ni,2);
Radii=NaN(Ni,1);
for ni=1:Ni
I1=Im(:,:,ni);
% The following is just copy-pasted from before
% 2/
t=140;
I2=imbinarize(I1,t);
% 3/ 
E=bwconncomp(I2);
prop=regionprops(E,'Centroid','EquivDiameter');
C=cat(1,prop.Centroid); % C now contains all the center of the objects of the image:
R=cat(1,prop.EquivDiameter)/2;
% 4/ 
im=find(R==max(R)); % find the biggest object 

Center(ni,:)=C(im,:);
Radii(ni)=R(im);
end

%% 7/ Plot the evolution of the droplet position and radius with time. 
figure(2)
subplot(1,2,1)
plot(Center(:,1),Center(:,2))
xlabel('x')
ylabel('y')
subplot(1,2,2)
plot(Radii)
xlabel('t')
ylabel('R')