close all 
clear all
clc

Ni=200;
Si=1000;
tau=20;
tau2=50;
t = (1:Ni);
R=15*sin(t.*2*pi/tau)+50;
x = Si/2+t./Ni*Si/3.*sin(t./tau2*2*pi);
y = Si/2+t./Ni*Si/3.*cos(t./tau2*2*pi);
plot(x,y)
I=repmat(1:Si,[Si,1]);
J=repmat((1:Si)',[1,Si]);

Cb=(1:Ni)/Ni*2*Si;
s1=20;
s2=5;


vid = VideoWriter('JumpingDroplet.AVI');
vid.FrameRate = 10;
open(vid);

for ni=1:Ni
    Im=rand(Si);
    Im=imgaussfilt(Im,10);
    Im((I-x(ni)).^2+(J-y(ni)).^2<R(ni).^2)=1;
    Im (J<Ni/2+s1 & J>Ni/2-2*s1 & I<Cb(ni)/2+s2 & I>Cb(ni)/2-s2)=1;
    Im (I<Ni/2+2*s1 & I>Ni/2-2*s1 & J<Cb(ni)+3*s2 & J>Cb(ni)-3*s2)=1;
    Im=Im+0.1*rand(size(Im));
    Im=uint8((Im-minmin(Im))/(maxmax(Im)-minmin(Im))*255);
    figure(1)
    imagesc(Im)
    colormap gray
    axis equal
    writeVideo(vid, Im);
end
close(vid)