close all 
clear all
clc

Ni=200;
Si=1000;
tau=20;
tau2=50;
t = (1:Ni);
R=50*(t-Ni/2).^2/Ni.^2+50;
x = t/Ni*Si;
y = Si/2+abs(mod(t,20)-10)/Ni*Si*3;
plot(x,y)
I=repmat(1:Si,[Si,1]);
J=repmat((1:Si)',[1,Si]);

Cb=(1:Ni)/Ni*2*Si;
s1=20;
s2=5;

vid = VideoWriter('JumpingDroplet3.AVI');
vid.FrameRate = 10;
open(vid);

for ni=1:Ni
    
    Im=rand(Si);
    Im=imgaussfilt(Im,10);
    Im((I-x(ni)).^2+(J-y(ni)).^2<R(ni).^2)=1;
    
    Nr=20;
    Rr=10;
    xr=rand(Nr,1)*Si;
    yr=rand(Nr,1)*Si;
    for nr=1:Nr    
        Im((I-xr(nr)).^2+(J-yr(nr)).^2<Rr.^2)=1;
    end
    Im=Im+0.1*rand(size(Im));
    Im=uint8((Im-minmin(Im))/(maxmax(Im)-minmin(Im))*255);
    figure(1)
    imagesc(Im)
    colormap gray
    axis equal
    writeVideo(vid, Im);
end
close(vid)