function [] = TypeOfSegmentation()
%% Typical exemple of methode to segment an object


Im=rgb2gray(imread('Segmentation_Type.PNG'));
Im(Im==172)=0;
se = strel('disk',5);
figure(1)
subplot(1,5,1)
imagesc(Im)
axis equal 
colormap gray
title('initial image')

% Intensity
I1=imbinarize(Im,0.9);
subplot(1,5,2)
imagesc(I1)
axis equal
title('Maximum intensity')

% Size
Int=unique(Im);
sze=NaN(numel(Int),1);
for i=2:numel(Int)
    sze(i)=size(find(Im==Int(i)),1);
end
[~,i_big]=max(sze);
I2=zeros(size(Im));
I2(Im==Int(i_big))=1;
subplot(1,5,3)
imagesc(I2)
axis equal
title('Biggest size')

% Position
[occ,Int]=groupcounts(Im(:));
Int(occ<100)=[];
ym=NaN(numel(Int),1);
xm=NaN(numel(Int),1);
for i=2:numel(Int)
    [x,y]=find(Im==Int(i));
    ym(i)=mean(y);
    xm(i)=mean(x);
end
[~,i_right]=min(ym);
I3=zeros(size(Im));
I3(Im==Int(i_right))=1;
subplot(1,5,4)
imagesc(I3)
colormap gray
axis equal
title('Most left')

% Shape
[occ,Int]=groupcounts(Im(:));
Int(occ<100)=[];
aspect=NaN(numel(Int),1);
for i=2:numel(Int)
    I=zeros(size(Im));
    I(Im==Int(i))=1;
    rp = regionprops(I,'MajorAxisLength','MinorAxisLength');
    aspect(i)=rp.MajorAxisLength/rp.MinorAxisLength;
end
[~,i_el]=max(aspect);
I4=zeros(size(Im));
I4(Im==Int(i_el))=1;
subplot(1,5,5)
imagesc(I4)
axis equal
title('Most elongated')

end

